Clazz.declarePackage ("jalview.schemes");
Clazz.load (["jalview.analysis.scoremodels.FeatureScoreModel", "$.PIDScoreModel", "jalview.schemes.ScoreMatrix", "java.awt.Color", "java.util.ArrayList", "$.HashMap", "$.Hashtable", "$.Vector"], "jalview.schemes.ResidueProperties", ["java.lang.StringBuffer"], function () {
c$ = Clazz.declareType (jalview.schemes, "ResidueProperties");
c$.buildAmbiguityCodonSet = Clazz.defineMethod (c$, "buildAmbiguityCodonSet", 
function () {
if (jalview.schemes.ResidueProperties._ambiguityCodes.size () > 0) {
System.err.println ("Ignoring multiple calls to buildAmbiguityCodonSet");
return;
}for (var acode, $acode = jalview.schemes.ResidueProperties.ambiguityCodes.entrySet ().iterator (); $acode.hasNext () && ((acode = $acode.next ()) || true);) {
for (var r, $r = 0, $$r = acode.getValue (); $r < $$r.length && ((r = $$r[$r]) || true); $r++) {
var codesfor = jalview.schemes.ResidueProperties._ambiguityCodes.get (r);
if (codesfor == null) {
jalview.schemes.ResidueProperties._ambiguityCodes.put (r, codesfor =  new java.util.ArrayList ());
}if (!codesfor.contains (acode.getKey ())) {
codesfor.add (acode.getKey ());
} else {
System.err.println ("Inconsistency in the IUBMB ambiguity code nomenclature table: collision for " + acode.getKey () + " in residue " + r);
}}
}
var unambcodons = jalview.schemes.ResidueProperties.codonHash2.keySet ().toArray ( new Array (jalview.schemes.ResidueProperties.codonHash2.size ()));
for (var codon, $codon = 0, $$codon = unambcodons; $codon < $$codon.length && ((codon = $$codon[$codon]) || true); $codon++) {
var residue = jalview.schemes.ResidueProperties.codonHash2.get (codon);
var acodon =  new Array (codon.length);
for (var i = 0, iSize = codon.length; i < iSize; i++) {
var _ac = "" + codon.charAt (i);
var acodes = jalview.schemes.ResidueProperties._ambiguityCodes.get (_ac);
if (acodes != null) {
acodon[i] = acodes.toArray ( new Array (acodes.size ()));
} else {
acodon[i] =  Clazz.newArray (-1, []);
}}
var tpos =  Clazz.newIntArray (codon.length, 0);
var cpos =  Clazz.newIntArray (codon.length, 0);
for (var i = 0; i < tpos.length; i++) {
tpos[i] = -1;
}
tpos[acodon.length - 1] = 0;
var ipos;
var j;
while (tpos[0] < acodon[0].length) {
var allres =  Clazz.newCharArray (tpos.length, '\0');
var _acodon = "";
var _anuc;
for (ipos = 0; ipos < tpos.length; ipos++) {
if (acodon[ipos].length == 0 || tpos[ipos] < 0) {
_acodon += codon.charAt (ipos);
allres[ipos] =  Clazz.newCharArray (-1, [codon.charAt (ipos)]);
} else {
_acodon += acodon[ipos][tpos[ipos]];
var altbase = jalview.schemes.ResidueProperties.ambiguityCodes.get (acodon[ipos][tpos[ipos]]);
allres[ipos] =  Clazz.newCharArray (altbase.length, '\0');
j = 0;
for (var ab, $ab = 0, $$ab = altbase; $ab < $$ab.length && ((ab = $$ab[$ab]) || true); $ab++) {
allres[ipos][j++] = ab.charAt (0);
}
}}
for (ipos = 0; ipos < cpos.length; ipos++) {
cpos[ipos] = 0;
}
var valid = true;
do {
var _codon = "";
for (j = 0; j < cpos.length; j++) {
_codon += allres[j][cpos[j]];
}
var tr = jalview.schemes.ResidueProperties.codonHash2.get (_codon);
if (valid = (tr != null && tr.equals (residue))) {
ipos = acodon.length - 1;
while (++cpos[ipos] >= allres[ipos].length && ipos > 0) {
cpos[ipos] = 0;
ipos--;
}
}} while (valid && cpos[0] < allres[0].length);
if (valid) {
jalview.schemes.ResidueProperties.codonHash2.put (_acodon, residue);
} else {
}ipos = acodon.length - 1;
while (++tpos[ipos] >= acodon[ipos].length && ipos > 0) {
tpos[ipos] = -1;
ipos--;
}
}
}
});
c$.getHydmax = Clazz.defineMethod (c$, "getHydmax", 
function () {
return 4.5;
});
c$.getHydmin = Clazz.defineMethod (c$, "getHydmin", 
function () {
return -3.9;
});
c$.getHyd = Clazz.defineMethod (c$, "getHyd", 
function () {
return jalview.schemes.ResidueProperties.hyd;
});
c$.getAA3Hash = Clazz.defineMethod (c$, "getAA3Hash", 
function () {
return jalview.schemes.ResidueProperties.aa3Hash;
});
c$.getDNA = Clazz.defineMethod (c$, "getDNA", 
function () {
return jalview.schemes.ResidueProperties.DNA;
});
c$.getBLOSUM62 = Clazz.defineMethod (c$, "getBLOSUM62", 
function () {
return jalview.schemes.ResidueProperties.BLOSUM62;
});
c$.getPAM250 = Clazz.defineMethod (c$, "getPAM250", 
function (A1, A2) {
return jalview.schemes.ResidueProperties.getPAM250 (A1.charAt (0), A2.charAt (0));
}, "~S,~S");
c$.getBLOSUM62 = Clazz.defineMethod (c$, "getBLOSUM62", 
function (c1, c2) {
var pog = 0;
try {
var a = jalview.schemes.ResidueProperties.aaIndex[c1.charCodeAt (0)];
var b = jalview.schemes.ResidueProperties.aaIndex[c2.charCodeAt (0)];
pog = jalview.schemes.ResidueProperties.BLOSUM62[a][b];
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
} else {
throw e;
}
}
return pog;
}, "~S,~S");
c$.getCodons = Clazz.defineMethod (c$, "getCodons", 
function (res) {
if (jalview.schemes.ResidueProperties.codonHash.containsKey (res)) {
return jalview.schemes.ResidueProperties.codonHash.get (res);
}return null;
}, "~S");
c$.codonTranslate = Clazz.defineMethod (c$, "codonTranslate", 
function (lccodon) {
if (false) {
return jalview.schemes.ResidueProperties._codonTranslate (lccodon);
}var cdn = jalview.schemes.ResidueProperties.codonHash2.get (lccodon.toUpperCase ());
if (cdn != null && cdn.equals ("*")) {
return "STOP";
}return cdn;
}, "~S");
c$._codonTranslate = Clazz.defineMethod (c$, "_codonTranslate", 
function (lccodon) {
var codon = lccodon.toUpperCase ();
if (codon.indexOf ('X') > -1 || codon.indexOf ('N') > -1) {
return "X";
}for (var key, $key = jalview.schemes.ResidueProperties.codonHash.keySet ().iterator (); $key.hasNext () && ((key = $key.next ()) || true);) {
if (jalview.schemes.ResidueProperties.codonHash.get (key).contains (codon)) {
return key;
}}
return null;
}, "~S");
c$.getDefaultPeptideMatrix = Clazz.defineMethod (c$, "getDefaultPeptideMatrix", 
function () {
return jalview.schemes.ResidueProperties.getBLOSUM62 ();
});
c$.getDefaultDnaMatrix = Clazz.defineMethod (c$, "getDefaultDnaMatrix", 
function () {
return jalview.schemes.ResidueProperties.getDNA ();
});
c$.getScoreMatrix = Clazz.defineMethod (c$, "getScoreMatrix", 
function (pwtype) {
var val = jalview.schemes.ResidueProperties.scoreMatrices.get (pwtype);
if (val != null && Clazz.instanceOf (val, jalview.schemes.ScoreMatrix)) {
return val;
}return null;
}, "~S");
c$.getScoreModel = Clazz.defineMethod (c$, "getScoreModel", 
function (pwtype) {
return jalview.schemes.ResidueProperties.scoreMatrices.get (pwtype);
}, "~S");
c$.getPAM250 = Clazz.defineMethod (c$, "getPAM250", 
function (c, d) {
var a = jalview.schemes.ResidueProperties.aaIndex[c.charCodeAt (0)];
var b = jalview.schemes.ResidueProperties.aaIndex[d.charCodeAt (0)];
var pog = jalview.schemes.ResidueProperties.PAM250[a][b];
return pog;
}, "~S,~S");
c$.getDssp3state = Clazz.defineMethod (c$, "getDssp3state", 
function (ssstring) {
if (ssstring == null) {
return null;
}var ss =  new StringBuffer ();
for (var i = 0; i < ssstring.length; i++) {
var ssc = ssstring.substring (i, i + 1);
if (jalview.schemes.ResidueProperties.toDssp3State.containsKey (ssc)) {
ss.append (jalview.schemes.ResidueProperties.toDssp3State.get (ssc));
} else {
ss.append (" ");
}}
return ss.toString ();
}, "~S");
c$.getRNASecStrucState = Clazz.defineMethod (c$, "getRNASecStrucState", 
function (ssstring) {
if (ssstring == null) {
return null;
}var ss =  new StringBuffer ();
for (var i = 0; i < ssstring.length; i++) {
var ssc = ssstring.substring (i, i + 1);
if (jalview.schemes.ResidueProperties.toRNAssState.containsKey (ssc)) {
ss.append (ssc);
} else {
ss.append (" ");
}}
return ss.toString ();
}, "~S");
c$.isCloseParenRNA = Clazz.defineMethod (c$, "isCloseParenRNA", 
function (dc) {
return jalview.schemes.ResidueProperties.RNAcloseParen[dc.charCodeAt (0)];
}, "~S");
c$.getResidues = Clazz.defineMethod (c$, "getResidues", 
function (nucleotide, includeAmbiguous) {
var result =  new java.util.ArrayList ();
if (nucleotide) {
for (var nuc, $nuc = jalview.schemes.ResidueProperties.nucleotideName.keySet ().iterator (); $nuc.hasNext () && ((nuc = $nuc.next ()) || true);) {
var val = jalview.schemes.ResidueProperties.nucleotideIndex[nuc.charCodeAt (0)];
if ((!includeAmbiguous && val > 4) || (val >= 10)) {
continue;
}nuc = nuc.toUpperCase ();
if (!result.contains (nuc)) {
result.add (nuc);
}}
} else {
for (var res, $res = jalview.schemes.ResidueProperties.aa3Hash.keySet ().iterator (); $res.hasNext () && ((res = $res.next ()) || true);) {
var index = jalview.schemes.ResidueProperties.aa3Hash.get (res).intValue ();
if ((!includeAmbiguous && index >= 20) || index >= 23) {
continue;
}res = res.toUpperCase ();
if (!result.contains (res)) {
result.add (res);
}}
}return result;
}, "~B,~B");
c$.scoreMatrices = c$.prototype.scoreMatrices =  new java.util.Hashtable ();
Clazz.defineStatics (c$,
"aaIndex", null,
"nucleotideIndex", null,
"purinepyrimidineIndex", null);
c$.aa3Hash = c$.prototype.aa3Hash =  new java.util.HashMap ();
c$.aa2Triplet = c$.prototype.aa2Triplet =  new java.util.HashMap ();
c$.nucleotideName = c$.prototype.nucleotideName =  new java.util.HashMap ();
{
jalview.schemes.ResidueProperties.aaIndex =  Clazz.newIntArray (255, 0);
for (var i = 0; i < 255; i++) {
jalview.schemes.ResidueProperties.aaIndex[i] = 23;
}
jalview.schemes.ResidueProperties.aaIndex['A'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.aaIndex['R'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.aaIndex['N'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.aaIndex['D'.charCodeAt (0)] = 3;
jalview.schemes.ResidueProperties.aaIndex['C'.charCodeAt (0)] = 4;
jalview.schemes.ResidueProperties.aaIndex['Q'.charCodeAt (0)] = 5;
jalview.schemes.ResidueProperties.aaIndex['E'.charCodeAt (0)] = 6;
jalview.schemes.ResidueProperties.aaIndex['G'.charCodeAt (0)] = 7;
jalview.schemes.ResidueProperties.aaIndex['H'.charCodeAt (0)] = 8;
jalview.schemes.ResidueProperties.aaIndex['I'.charCodeAt (0)] = 9;
jalview.schemes.ResidueProperties.aaIndex['L'.charCodeAt (0)] = 10;
jalview.schemes.ResidueProperties.aaIndex['K'.charCodeAt (0)] = 11;
jalview.schemes.ResidueProperties.aaIndex['M'.charCodeAt (0)] = 12;
jalview.schemes.ResidueProperties.aaIndex['F'.charCodeAt (0)] = 13;
jalview.schemes.ResidueProperties.aaIndex['P'.charCodeAt (0)] = 14;
jalview.schemes.ResidueProperties.aaIndex['S'.charCodeAt (0)] = 15;
jalview.schemes.ResidueProperties.aaIndex['T'.charCodeAt (0)] = 16;
jalview.schemes.ResidueProperties.aaIndex['W'.charCodeAt (0)] = 17;
jalview.schemes.ResidueProperties.aaIndex['Y'.charCodeAt (0)] = 18;
jalview.schemes.ResidueProperties.aaIndex['V'.charCodeAt (0)] = 19;
jalview.schemes.ResidueProperties.aaIndex['B'.charCodeAt (0)] = 20;
jalview.schemes.ResidueProperties.aaIndex['Z'.charCodeAt (0)] = 21;
jalview.schemes.ResidueProperties.aaIndex['X'.charCodeAt (0)] = 22;
jalview.schemes.ResidueProperties.aaIndex['U'.charCodeAt (0)] = 22;
jalview.schemes.ResidueProperties.aaIndex['a'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.aaIndex['r'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.aaIndex['n'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.aaIndex['d'.charCodeAt (0)] = 3;
jalview.schemes.ResidueProperties.aaIndex['c'.charCodeAt (0)] = 4;
jalview.schemes.ResidueProperties.aaIndex['q'.charCodeAt (0)] = 5;
jalview.schemes.ResidueProperties.aaIndex['e'.charCodeAt (0)] = 6;
jalview.schemes.ResidueProperties.aaIndex['g'.charCodeAt (0)] = 7;
jalview.schemes.ResidueProperties.aaIndex['h'.charCodeAt (0)] = 8;
jalview.schemes.ResidueProperties.aaIndex['i'.charCodeAt (0)] = 9;
jalview.schemes.ResidueProperties.aaIndex['l'.charCodeAt (0)] = 10;
jalview.schemes.ResidueProperties.aaIndex['k'.charCodeAt (0)] = 11;
jalview.schemes.ResidueProperties.aaIndex['m'.charCodeAt (0)] = 12;
jalview.schemes.ResidueProperties.aaIndex['f'.charCodeAt (0)] = 13;
jalview.schemes.ResidueProperties.aaIndex['p'.charCodeAt (0)] = 14;
jalview.schemes.ResidueProperties.aaIndex['s'.charCodeAt (0)] = 15;
jalview.schemes.ResidueProperties.aaIndex['t'.charCodeAt (0)] = 16;
jalview.schemes.ResidueProperties.aaIndex['w'.charCodeAt (0)] = 17;
jalview.schemes.ResidueProperties.aaIndex['y'.charCodeAt (0)] = 18;
jalview.schemes.ResidueProperties.aaIndex['v'.charCodeAt (0)] = 19;
jalview.schemes.ResidueProperties.aaIndex['b'.charCodeAt (0)] = 20;
jalview.schemes.ResidueProperties.aaIndex['z'.charCodeAt (0)] = 21;
jalview.schemes.ResidueProperties.aaIndex['x'.charCodeAt (0)] = 22;
jalview.schemes.ResidueProperties.aaIndex['u'.charCodeAt (0)] = 22;
}Clazz.defineStatics (c$,
"maxProteinIndex", 23,
"maxNucleotideIndex", 10);
{
jalview.schemes.ResidueProperties.nucleotideIndex =  Clazz.newIntArray (255, 0);
for (var i = 0; i < 255; i++) {
jalview.schemes.ResidueProperties.nucleotideIndex[i] = 10;
}
jalview.schemes.ResidueProperties.nucleotideIndex['A'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.nucleotideIndex['a'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.nucleotideIndex['C'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.nucleotideIndex['c'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.nucleotideIndex['G'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.nucleotideIndex['g'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.nucleotideIndex['T'.charCodeAt (0)] = 3;
jalview.schemes.ResidueProperties.nucleotideIndex['t'.charCodeAt (0)] = 3;
jalview.schemes.ResidueProperties.nucleotideIndex['U'.charCodeAt (0)] = 4;
jalview.schemes.ResidueProperties.nucleotideIndex['u'.charCodeAt (0)] = 4;
jalview.schemes.ResidueProperties.nucleotideIndex['I'.charCodeAt (0)] = 5;
jalview.schemes.ResidueProperties.nucleotideIndex['i'.charCodeAt (0)] = 5;
jalview.schemes.ResidueProperties.nucleotideIndex['X'.charCodeAt (0)] = 6;
jalview.schemes.ResidueProperties.nucleotideIndex['x'.charCodeAt (0)] = 6;
jalview.schemes.ResidueProperties.nucleotideIndex['R'.charCodeAt (0)] = 7;
jalview.schemes.ResidueProperties.nucleotideIndex['r'.charCodeAt (0)] = 7;
jalview.schemes.ResidueProperties.nucleotideIndex['Y'.charCodeAt (0)] = 8;
jalview.schemes.ResidueProperties.nucleotideIndex['y'.charCodeAt (0)] = 8;
jalview.schemes.ResidueProperties.nucleotideIndex['N'.charCodeAt (0)] = 9;
jalview.schemes.ResidueProperties.nucleotideIndex['n'.charCodeAt (0)] = 9;
jalview.schemes.ResidueProperties.nucleotideName.put ("A", "Adenine");
jalview.schemes.ResidueProperties.nucleotideName.put ("a", "Adenine");
jalview.schemes.ResidueProperties.nucleotideName.put ("G", "Guanine");
jalview.schemes.ResidueProperties.nucleotideName.put ("g", "Guanine");
jalview.schemes.ResidueProperties.nucleotideName.put ("C", "Cytosine");
jalview.schemes.ResidueProperties.nucleotideName.put ("c", "Cytosine");
jalview.schemes.ResidueProperties.nucleotideName.put ("T", "Thymine");
jalview.schemes.ResidueProperties.nucleotideName.put ("t", "Thymine");
jalview.schemes.ResidueProperties.nucleotideName.put ("U", "Uracil");
jalview.schemes.ResidueProperties.nucleotideName.put ("u", "Uracil");
jalview.schemes.ResidueProperties.nucleotideName.put ("I", "Inosine");
jalview.schemes.ResidueProperties.nucleotideName.put ("i", "Inosine");
jalview.schemes.ResidueProperties.nucleotideName.put ("X", "Xanthine");
jalview.schemes.ResidueProperties.nucleotideName.put ("x", "Xanthine");
jalview.schemes.ResidueProperties.nucleotideName.put ("R", "Unknown Purine");
jalview.schemes.ResidueProperties.nucleotideName.put ("r", "Unknown Purine");
jalview.schemes.ResidueProperties.nucleotideName.put ("Y", "Unknown Pyrimidine");
jalview.schemes.ResidueProperties.nucleotideName.put ("y", "Unknown Pyrimidine");
jalview.schemes.ResidueProperties.nucleotideName.put ("N", "Unknown");
jalview.schemes.ResidueProperties.nucleotideName.put ("n", "Unknown");
jalview.schemes.ResidueProperties.nucleotideName.put ("W", "Weak nucleotide (A or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("w", "Weak nucleotide (A or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("S", "Strong nucleotide (G or C)");
jalview.schemes.ResidueProperties.nucleotideName.put ("s", "Strong nucleotide (G or C)");
jalview.schemes.ResidueProperties.nucleotideName.put ("M", "Amino (A or C)");
jalview.schemes.ResidueProperties.nucleotideName.put ("m", "Amino (A or C)");
jalview.schemes.ResidueProperties.nucleotideName.put ("K", "Keto (G or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("k", "Keto (G or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("B", "Not A (G or C or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("b", "Not A (G or C or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("H", "Not G (A or C or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("h", "Not G (A or C or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("D", "Not C (A or G or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("d", "Not C (A or G or T)");
jalview.schemes.ResidueProperties.nucleotideName.put ("V", "Not T (A or G or C");
jalview.schemes.ResidueProperties.nucleotideName.put ("v", "Not T (A or G or C");
}{
jalview.schemes.ResidueProperties.purinepyrimidineIndex =  Clazz.newIntArray (255, 0);
for (var i = 0; i < 255; i++) {
jalview.schemes.ResidueProperties.purinepyrimidineIndex[i] = 3;
}
jalview.schemes.ResidueProperties.purinepyrimidineIndex['A'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['a'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['C'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['c'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['G'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['g'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['T'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['t'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['U'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['u'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['I'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['i'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['X'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['x'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['R'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['r'.charCodeAt (0)] = 0;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['Y'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['y'.charCodeAt (0)] = 1;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['N'.charCodeAt (0)] = 2;
jalview.schemes.ResidueProperties.purinepyrimidineIndex['n'.charCodeAt (0)] = 2;
}{
jalview.schemes.ResidueProperties.aa3Hash.put ("ALA",  new Integer (0));
jalview.schemes.ResidueProperties.aa3Hash.put ("ARG",  new Integer (1));
jalview.schemes.ResidueProperties.aa3Hash.put ("ASN",  new Integer (2));
jalview.schemes.ResidueProperties.aa3Hash.put ("ASP",  new Integer (3));
jalview.schemes.ResidueProperties.aa3Hash.put ("CYS",  new Integer (4));
jalview.schemes.ResidueProperties.aa3Hash.put ("GLN",  new Integer (5));
jalview.schemes.ResidueProperties.aa3Hash.put ("GLU",  new Integer (6));
jalview.schemes.ResidueProperties.aa3Hash.put ("GLY",  new Integer (7));
jalview.schemes.ResidueProperties.aa3Hash.put ("HIS",  new Integer (8));
jalview.schemes.ResidueProperties.aa3Hash.put ("ILE",  new Integer (9));
jalview.schemes.ResidueProperties.aa3Hash.put ("LEU",  new Integer (10));
jalview.schemes.ResidueProperties.aa3Hash.put ("LYS",  new Integer (11));
jalview.schemes.ResidueProperties.aa3Hash.put ("MET",  new Integer (12));
jalview.schemes.ResidueProperties.aa3Hash.put ("PHE",  new Integer (13));
jalview.schemes.ResidueProperties.aa3Hash.put ("PRO",  new Integer (14));
jalview.schemes.ResidueProperties.aa3Hash.put ("SER",  new Integer (15));
jalview.schemes.ResidueProperties.aa3Hash.put ("THR",  new Integer (16));
jalview.schemes.ResidueProperties.aa3Hash.put ("TRP",  new Integer (17));
jalview.schemes.ResidueProperties.aa3Hash.put ("TYR",  new Integer (18));
jalview.schemes.ResidueProperties.aa3Hash.put ("VAL",  new Integer (19));
jalview.schemes.ResidueProperties.aa3Hash.put ("ASX",  new Integer (20));
jalview.schemes.ResidueProperties.aa3Hash.put ("GLX",  new Integer (21));
jalview.schemes.ResidueProperties.aa3Hash.put ("XAA",  new Integer (22));
jalview.schemes.ResidueProperties.aa3Hash.put ("-",  new Integer (23));
jalview.schemes.ResidueProperties.aa3Hash.put ("*",  new Integer (23));
jalview.schemes.ResidueProperties.aa3Hash.put (".",  new Integer (23));
jalview.schemes.ResidueProperties.aa3Hash.put (" ",  new Integer (23));
jalview.schemes.ResidueProperties.aa3Hash.put ("Gap",  new Integer (23));
}{
jalview.schemes.ResidueProperties.aa2Triplet.put ("A", "ALA");
jalview.schemes.ResidueProperties.aa2Triplet.put ("a", "ALA");
jalview.schemes.ResidueProperties.aa2Triplet.put ("R", "ARG");
jalview.schemes.ResidueProperties.aa2Triplet.put ("r", "ARG");
jalview.schemes.ResidueProperties.aa2Triplet.put ("N", "ASN");
jalview.schemes.ResidueProperties.aa2Triplet.put ("n", "ASN");
jalview.schemes.ResidueProperties.aa2Triplet.put ("D", "ASP");
jalview.schemes.ResidueProperties.aa2Triplet.put ("d", "ASP");
jalview.schemes.ResidueProperties.aa2Triplet.put ("C", "CYS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("c", "CYS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("Q", "GLN");
jalview.schemes.ResidueProperties.aa2Triplet.put ("q", "GLN");
jalview.schemes.ResidueProperties.aa2Triplet.put ("E", "GLU");
jalview.schemes.ResidueProperties.aa2Triplet.put ("e", "GLU");
jalview.schemes.ResidueProperties.aa2Triplet.put ("G", "GLY");
jalview.schemes.ResidueProperties.aa2Triplet.put ("g", "GLY");
jalview.schemes.ResidueProperties.aa2Triplet.put ("H", "HIS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("h", "HIS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("I", "ILE");
jalview.schemes.ResidueProperties.aa2Triplet.put ("i", "ILE");
jalview.schemes.ResidueProperties.aa2Triplet.put ("L", "LEU");
jalview.schemes.ResidueProperties.aa2Triplet.put ("l", "LEU");
jalview.schemes.ResidueProperties.aa2Triplet.put ("K", "LYS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("k", "LYS");
jalview.schemes.ResidueProperties.aa2Triplet.put ("M", "MET");
jalview.schemes.ResidueProperties.aa2Triplet.put ("m", "MET");
jalview.schemes.ResidueProperties.aa2Triplet.put ("F", "PHE");
jalview.schemes.ResidueProperties.aa2Triplet.put ("f", "PHE");
jalview.schemes.ResidueProperties.aa2Triplet.put ("P", "PRO");
jalview.schemes.ResidueProperties.aa2Triplet.put ("p", "PRO");
jalview.schemes.ResidueProperties.aa2Triplet.put ("S", "SER");
jalview.schemes.ResidueProperties.aa2Triplet.put ("s", "SER");
jalview.schemes.ResidueProperties.aa2Triplet.put ("T", "THR");
jalview.schemes.ResidueProperties.aa2Triplet.put ("t", "THR");
jalview.schemes.ResidueProperties.aa2Triplet.put ("W", "TRP");
jalview.schemes.ResidueProperties.aa2Triplet.put ("w", "TRP");
jalview.schemes.ResidueProperties.aa2Triplet.put ("Y", "TYR");
jalview.schemes.ResidueProperties.aa2Triplet.put ("y", "TYR");
jalview.schemes.ResidueProperties.aa2Triplet.put ("V", "VAL");
jalview.schemes.ResidueProperties.aa2Triplet.put ("v", "VAL");
}Clazz.defineStatics (c$,
"aa",  Clazz.newArray (-1, ["A", "R", "N", "D", "C", "Q", "E", "G", "H", "I", "L", "K", "M", "F", "P", "S", "T", "W", "Y", "V", "B", "Z", "X", "_", "*", ".", " "]));
c$.midBlue = c$.prototype.midBlue =  new java.awt.Color (100, 100, 255);
c$.scaleColours = c$.prototype.scaleColours =  new java.util.Vector ();
{
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (114, 0, 147));
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (156, 0, 98));
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (190, 0, 0));
jalview.schemes.ResidueProperties.scaleColours.addElement (java.awt.Color.red);
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (255, 125, 0));
jalview.schemes.ResidueProperties.scaleColours.addElement (java.awt.Color.orange);
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (255, 194, 85));
jalview.schemes.ResidueProperties.scaleColours.addElement (java.awt.Color.yellow);
jalview.schemes.ResidueProperties.scaleColours.addElement ( new java.awt.Color (255, 255, 181));
jalview.schemes.ResidueProperties.scaleColours.addElement (java.awt.Color.white);
}c$.taylor = c$.prototype.taylor =  Clazz.newArray (-1, [ new java.awt.Color (204, 255, 0),  new java.awt.Color (0, 0, 255),  new java.awt.Color (204, 0, 255),  new java.awt.Color (255, 0, 0),  new java.awt.Color (255, 255, 0),  new java.awt.Color (255, 0, 204),  new java.awt.Color (255, 0, 102),  new java.awt.Color (255, 153, 0),  new java.awt.Color (0, 102, 255),  new java.awt.Color (102, 255, 0),  new java.awt.Color (51, 255, 0),  new java.awt.Color (102, 0, 255),  new java.awt.Color (0, 255, 0),  new java.awt.Color (0, 255, 102),  new java.awt.Color (255, 204, 0),  new java.awt.Color (255, 51, 0),  new java.awt.Color (255, 102, 0),  new java.awt.Color (0, 204, 255),  new java.awt.Color (0, 255, 204),  new java.awt.Color (153, 255, 0), java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white]);
c$.nucleotide = c$.prototype.nucleotide =  Clazz.newArray (-1, [ new java.awt.Color (100, 247, 63),  new java.awt.Color (255, 179, 64),  new java.awt.Color (235, 65, 60),  new java.awt.Color (60, 136, 238),  new java.awt.Color (60, 136, 238), java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white]);
c$.purinepyrimidine = c$.prototype.purinepyrimidine =  Clazz.newArray (-1, [ new java.awt.Color (255, 131, 250),  new java.awt.Color (64, 224, 208), java.awt.Color.white, java.awt.Color.white]);
c$.zappo = c$.prototype.zappo =  Clazz.newArray (-1, [java.awt.Color.pink, jalview.schemes.ResidueProperties.midBlue, java.awt.Color.green, java.awt.Color.red, java.awt.Color.yellow, java.awt.Color.green, java.awt.Color.red, java.awt.Color.magenta, jalview.schemes.ResidueProperties.midBlue, java.awt.Color.pink, java.awt.Color.pink, jalview.schemes.ResidueProperties.midBlue, java.awt.Color.pink, java.awt.Color.orange, java.awt.Color.magenta, java.awt.Color.green, java.awt.Color.green, java.awt.Color.orange, java.awt.Color.orange, java.awt.Color.pink, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white, java.awt.Color.white]);
Clazz.defineStatics (c$,
"hyd2",  Clazz.newDoubleArray (-1, [0.62, 0.29, -0.9, -0.74, 1.19, 0.48, -0.4, 1.38, -1.5, 1.06, 0.64, -0.78, 0.12, -0.85, -2.53, -0.18, -0.05, 1.08, 0.81, 0.0, 0.26, 0.0, 0.0]),
"helix",  Clazz.newDoubleArray (-1, [1.42, 0.98, 0.67, 1.01, 0.70, 1.11, 1.51, 0.57, 1.00, 1.08, 1.21, 1.16, 1.45, 1.13, 0.57, 0.77, 0.83, 1.08, 0.69, 1.06, 0.84, 1.31, 1.00, 0.0]),
"helixmin", 0.57,
"helixmax", 1.51,
"strand",  Clazz.newDoubleArray (-1, [0.83, 0.93, 0.89, 0.54, 1.19, 1.10, 0.37, 0.75, 0.87, 1.60, 1.30, 0.74, 1.05, 1.38, 0.55, 0.75, 1.19, 1.37, 1.47, 1.70, 0.72, 0.74, 1.0, 0.0]),
"strandmin", 0.37,
"strandmax", 1.7,
"turn",  Clazz.newDoubleArray (-1, [0.66, 0.95, 1.56, 1.46, 1.19, 0.98, 0.74, 1.56, 0.95, 0.47, 0.59, 1.01, 0.60, 0.60, 1.52, 1.43, 0.96, 0.96, 1.14, 0.50, 1.51, 0.86, 1.00, 0, 0]),
"turnmin", 0.47,
"turnmax", 1.56,
"buried",  Clazz.newDoubleArray (-1, [1.7, 0.1, 0.4, 0.4, 4.6, 0.3, 0.3, 1.8, 0.8, 3.1, 2.4, 0.05, 1.9, 2.2, 0.6, 0.8, 0.7, 1.6, 0.5, 2.9, 0.4, 0.3, 1.358, 0.00]),
"buriedmin", 0.05,
"buriedmax", 4.6,
"hyd",  Clazz.newDoubleArray (-1, [1.8, -4.5, -3.5, -3.5, 2.5, -3.5, -3.5, -0.4, -3.2, 4.5, 3.8, -3.9, 1.9, 2.8, -1.6, -0.8, -0.7, -0.9, -1.3, 4.2, -3.5, -3.5, -0.49, 0.0]),
"hydmax", 4.5,
"hydmin", -3.9,
"BLOSUM62",  Clazz.newArray (-1, [ Clazz.newIntArray (-1, [4, -1, -2, -2, 0, -1, -1, 0, -2, -1, -1, -1, -1, -2, -1, 1, 0, -3, -2, 0, -2, -1, 0, -4]),  Clazz.newIntArray (-1, [-1, 5, 0, -2, -3, 1, 0, -2, 0, -3, -2, 2, -1, -3, -2, -1, -1, -3, -2, -3, -1, 0, -1, -4]),  Clazz.newIntArray (-1, [-2, 0, 6, 1, -3, 0, 0, 0, 1, -3, -3, 0, -2, -3, -2, 1, 0, -4, -2, -3, 3, 0, -1, -4]),  Clazz.newIntArray (-1, [-2, -2, 1, 6, -3, 0, 2, -1, -1, -3, -4, -1, -3, -3, -1, 0, -1, -4, -3, -3, 4, 1, -1, -4]),  Clazz.newIntArray (-1, [0, 3, -3, -3, 9, -3, -4, -3, -3, -1, -1, -3, -1, -2, -3, -1, -1, -2, -2, -1, -3, -3, -2, -4]),  Clazz.newIntArray (-1, [-1, 1, 0, 0, -3, 5, 2, -2, 0, -3, -2, 1, 0, -3, -1, 0, -1, -2, -1, -2, 0, 3, -1, -4]),  Clazz.newIntArray (-1, [-1, 0, 0, 2, -4, 2, 5, -2, 0, -3, -3, 1, -2, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -4]),  Clazz.newIntArray (-1, [0, -2, 0, -1, -3, -2, -2, 6, -2, -4, -4, -2, -3, -3, -2, 0, -2, -2, -3, -3, -1, -2, -1, -4]),  Clazz.newIntArray (-1, [-2, 0, 1, -1, -3, 0, 0, -2, 8, -3, -3, -1, -2, -1, -2, -1, -2, -2, 2, -3, 0, 0, -1, -4]),  Clazz.newIntArray (-1, [-1, -3, -3, -3, -1, -3, -3, -4, -3, 4, 2, -3, 1, 0, -3, -2, -1, -3, -1, 3, -3, -3, -1, -4]),  Clazz.newIntArray (-1, [-1, -2, -3, -4, -1, -2, -3, -4, -3, 2, 4, -2, 2, 0, -3, -2, -1, -2, -1, 1, -4, -3, -1, -4]),  Clazz.newIntArray (-1, [-1, 2, 0, -1, -3, 1, 1, -2, -1, -3, -2, 5, -1, -3, -1, 0, -1, -3, -2, -2, 0, 1, -1, -4]),  Clazz.newIntArray (-1, [-1, -1, -2, -3, -1, 0, -2, -3, -2, 1, 2, -1, 5, 0, -2, -1, -1, -1, -1, 1, -3, -1, -1, -4]),  Clazz.newIntArray (-1, [-2, -3, -3, -3, -2, -3, -3, -3, -1, 0, 0, -3, 0, 6, -4, -2, -2, 1, 3, -1, -3, -3, -1, -4]),  Clazz.newIntArray (-1, [-1, -2, -2, -1, -3, -1, -1, -2, -2, -3, -3, -1, -2, -4, 7, -1, -1, -4, -3, -2, -2, -1, -2, -4]),  Clazz.newIntArray (-1, [1, -1, 1, 0, -1, 0, 0, 0, -1, -2, -2, 0, -1, -2, -1, 4, 1, -3, -2, -2, 0, 0, 0, -4]),  Clazz.newIntArray (-1, [0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1, 1, 5, -2, -2, 0, -1, -1, 0, -4]),  Clazz.newIntArray (-1, [-3, -3, -4, -4, -2, -2, -3, -2, -2, -3, -2, -3, -1, 1, -4, -3, -2, 11, 2, -3, -4, -3, -2, -4]),  Clazz.newIntArray (-1, [-2, -2, -2, -3, -2, -1, -2, -3, 2, -1, -1, -2, -1, 3, -3, -2, -2, 2, 7, -1, -3, -2, -1, -4]),  Clazz.newIntArray (-1, [0, -3, -3, -3, -1, -2, -2, -3, -3, 3, 1, -2, 1, -1, -2, -2, 0, -3, -1, 4, -3, -2, -1, -4]),  Clazz.newIntArray (-1, [-2, -1, 3, 4, -3, 0, 1, -1, 0, -3, -4, 0, -3, -3, -2, 0, -1, -4, -3, -3, 4, 1, -1, -4]),  Clazz.newIntArray (-1, [-1, 0, 0, 1, -3, 3, 4, -2, 0, -3, -3, 1, -1, -3, -1, 0, -1, -3, -2, -2, 1, 4, -1, -4]),  Clazz.newIntArray (-1, [0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2, 0, 0, -2, -1, -1, -1, -1, -1, -4]),  Clazz.newIntArray (-1, [-4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, 1])]),
"PAM250",  Clazz.newArray (-1, [ Clazz.newIntArray (-1, [2, -2, 0, 0, -2, 0, 0, 1, -1, -1, -2, -1, -1, -3, 1, 1, 1, -6, -3, 0, 0, 0, 0, -8]),  Clazz.newIntArray (-1, [-2, 6, 0, -1, -4, 1, -1, -3, 2, -2, -3, 3, 0, -4, 0, 0, -1, 2, -4, -2, -1, 0, -1, -8]),  Clazz.newIntArray (-1, [0, 0, 2, 2, -4, 1, 1, 0, 2, -2, -3, 1, -2, -3, 0, 1, 0, -4, -2, -2, 2, 1, 0, -8]),  Clazz.newIntArray (-1, [0, -1, 2, 4, -5, 2, 3, 1, 1, -2, -4, 0, -3, -6, -1, 0, 0, -7, -4, -2, 3, 3, -1, -8]),  Clazz.newIntArray (-1, [-2, -4, -4, -5, 12, -5, -5, -3, -3, -2, -6, -5, -5, -4, -3, 0, -2, -8, 0, -2, -4, -5, -3, -8]),  Clazz.newIntArray (-1, [0, 1, 1, 2, -5, 4, 2, -1, 3, -2, -2, 1, -1, -5, 0, -1, -1, -5, -4, -2, 1, 3, -1, -8]),  Clazz.newIntArray (-1, [0, -1, 1, 3, -5, 2, 4, 0, 1, -2, -3, 0, -2, -5, -1, 0, 0, -7, -4, -2, 3, 3, -1, -8]),  Clazz.newIntArray (-1, [1, -3, 0, 1, -3, -1, 0, 5, -2, -3, -4, -2, -3, -5, 0, 1, 0, -7, -5, -1, 0, 0, -1, -8]),  Clazz.newIntArray (-1, [-1, 2, 2, 1, -3, 3, 1, -2, 6, -2, -2, 0, -2, -2, 0, -1, -1, -3, 0, -2, 1, 2, -1, -8]),  Clazz.newIntArray (-1, [-1, -2, -2, -2, -2, -2, -2, -3, -2, 5, 2, -2, 2, 1, -2, -1, 0, -5, -1, 4, -2, -2, -1, -8]),  Clazz.newIntArray (-1, [-2, -3, -3, -4, -6, -2, -3, -4, -2, 2, 6, -3, 4, 2, -3, -3, -2, -2, -1, 2, -3, -3, -1, -8]),  Clazz.newIntArray (-1, [-1, 3, 1, 0, -5, 1, 0, -2, 0, -2, -3, 5, 0, -5, -1, 0, 0, -3, -4, -2, 1, 0, -1, -8]),  Clazz.newIntArray (-1, [-1, 0, -2, -3, -5, -1, -2, -3, -2, 2, 4, 0, 6, 0, -2, -2, -1, -4, -2, 2, -2, -2, -1, -8]),  Clazz.newIntArray (-1, [-3, -4, -3, -6, -4, -5, -5, -5, -2, 1, 2, -5, 0, 9, -5, -3, -3, 0, 7, -1, -4, -5, -2, -8]),  Clazz.newIntArray (-1, [1, 0, 0, -1, -3, 0, -1, 0, 0, -2, -3, -1, -2, -5, 6, 1, 0, -6, -5, -1, -1, 0, -1, -8]),  Clazz.newIntArray (-1, [1, 0, 1, 0, 0, -1, 0, 1, -1, -1, -3, 0, -2, -3, 1, 2, 1, -2, -3, -1, 0, 0, 0, -8]),  Clazz.newIntArray (-1, [1, -1, 0, 0, -2, -1, 0, 0, -1, 0, -2, 0, -1, -3, 0, 1, 3, -5, -3, 0, 0, -1, 0, -8]),  Clazz.newIntArray (-1, [-6, 2, -4, -7, -8, -5, -7, -7, -3, -5, -2, -3, -4, 0, -6, -2, -5, 17, 0, -6, -5, -6, -4, -8]),  Clazz.newIntArray (-1, [-3, -4, -2, -4, 0, -4, -4, -5, 0, -1, -1, -4, -2, 7, -5, -3, -3, 0, 10, -2, -3, -4, -2, -8]),  Clazz.newIntArray (-1, [0, -2, -2, -2, -2, -2, -2, -1, -2, 4, 2, -2, 2, -1, -1, -1, 0, -6, -2, 4, -2, -2, -1, -8]),  Clazz.newIntArray (-1, [0, -1, 2, 3, -4, 1, 3, 0, 1, -2, -3, 1, -2, -4, -1, 0, 0, -5, -3, -2, 3, 2, -1, -8]),  Clazz.newIntArray (-1, [0, 0, 1, 3, -5, 3, 3, 0, 2, -2, -3, 0, -2, -5, 0, 0, -1, -6, -4, -2, 2, 3, -1, -8]),  Clazz.newIntArray (-1, [0, -1, 0, -1, -3, -1, -1, -1, -1, -1, -1, -1, -1, -2, -1, 0, 0, -4, -2, -1, -1, -1, -1, -8]),  Clazz.newIntArray (-1, [-8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, -8, 1])]));
c$.ssHash = c$.prototype.ssHash =  new java.util.Hashtable ();
{
jalview.schemes.ResidueProperties.ssHash.put ("H", java.awt.Color.magenta);
jalview.schemes.ResidueProperties.ssHash.put ("E", java.awt.Color.yellow);
jalview.schemes.ResidueProperties.ssHash.put ("-", java.awt.Color.white);
jalview.schemes.ResidueProperties.ssHash.put (".", java.awt.Color.white);
jalview.schemes.ResidueProperties.ssHash.put ("S", java.awt.Color.cyan);
jalview.schemes.ResidueProperties.ssHash.put ("T", java.awt.Color.blue);
jalview.schemes.ResidueProperties.ssHash.put ("G", java.awt.Color.pink);
jalview.schemes.ResidueProperties.ssHash.put ("I", java.awt.Color.pink);
jalview.schemes.ResidueProperties.ssHash.put ("B", java.awt.Color.yellow);
}Clazz.defineStatics (c$,
"DNA",  Clazz.newArray (-1, [ Clazz.newIntArray (-1, [10, -8, -8, -8, -8, 1, 1, 1, -8, 1, 1]),  Clazz.newIntArray (-1, [-8, 10, -8, -8, -8, 1, 1, -8, 1, 1, 1]),  Clazz.newIntArray (-1, [-8, -8, 10, -8, -8, 1, 1, 1, -8, 1, 1]),  Clazz.newIntArray (-1, [-8, -8, -8, 10, 10, 1, 1, -8, 1, 1, 1]),  Clazz.newIntArray (-1, [-8, -8, -8, 10, 10, 1, 1, -8, 1, 1, 1]),  Clazz.newIntArray (-1, [1, 1, 1, 1, 1, 10, 0, 0, 0, 1, 1]),  Clazz.newIntArray (-1, [1, 1, 1, 1, 1, 0, 10, 0, 0, 1, 1]),  Clazz.newIntArray (-1, [1, -8, 1, -8, -8, 0, 0, 10, -8, 1, 1]),  Clazz.newIntArray (-1, [-8, 1, -8, 1, 1, 0, 0, -8, 10, 1, 1]),  Clazz.newIntArray (-1, [1, 1, 1, 1, 1, 1, 1, 1, 1, 10, 1]),  Clazz.newIntArray (-1, [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])]));
{
jalview.schemes.ResidueProperties.scoreMatrices.put ("BLOSUM62",  new jalview.schemes.ScoreMatrix ("BLOSUM62", jalview.schemes.ResidueProperties.BLOSUM62, 0));
jalview.schemes.ResidueProperties.scoreMatrices.put ("PAM250",  new jalview.schemes.ScoreMatrix ("PAM250", jalview.schemes.ResidueProperties.PAM250, 0));
jalview.schemes.ResidueProperties.scoreMatrices.put ("DNA",  new jalview.schemes.ScoreMatrix ("DNA", jalview.schemes.ResidueProperties.DNA, 1));
}c$.pidColours = c$.prototype.pidColours =  Clazz.newArray (-1, [jalview.schemes.ResidueProperties.midBlue,  new java.awt.Color (153, 153, 255),  new java.awt.Color (204, 204, 255)]);
Clazz.defineStatics (c$,
"pidThresholds",  Clazz.newFloatArray (-1, [80, 60, 40]));
c$.codonHash = c$.prototype.codonHash =  new java.util.HashMap ();
c$.Lys = c$.prototype.Lys =  new java.util.ArrayList ();
c$.Asn = c$.prototype.Asn =  new java.util.ArrayList ();
c$.Gln = c$.prototype.Gln =  new java.util.ArrayList ();
c$.His = c$.prototype.His =  new java.util.ArrayList ();
c$.Glu = c$.prototype.Glu =  new java.util.ArrayList ();
c$.Asp = c$.prototype.Asp =  new java.util.ArrayList ();
c$.Tyr = c$.prototype.Tyr =  new java.util.ArrayList ();
c$.Thr = c$.prototype.Thr =  new java.util.ArrayList ();
c$.Pro = c$.prototype.Pro =  new java.util.ArrayList ();
c$.Ala = c$.prototype.Ala =  new java.util.ArrayList ();
c$.Ser = c$.prototype.Ser =  new java.util.ArrayList ();
c$.Arg = c$.prototype.Arg =  new java.util.ArrayList ();
c$.Gly = c$.prototype.Gly =  new java.util.ArrayList ();
c$.Trp = c$.prototype.Trp =  new java.util.ArrayList ();
c$.Cys = c$.prototype.Cys =  new java.util.ArrayList ();
c$.Ile = c$.prototype.Ile =  new java.util.ArrayList ();
c$.Met = c$.prototype.Met =  new java.util.ArrayList ();
c$.Leu = c$.prototype.Leu =  new java.util.ArrayList ();
c$.Val = c$.prototype.Val =  new java.util.ArrayList ();
c$.Phe = c$.prototype.Phe =  new java.util.ArrayList ();
c$.STOP = c$.prototype.STOP =  new java.util.ArrayList ();
Clazz.defineStatics (c$,
"START", "ATG");
{
jalview.schemes.ResidueProperties.codonHash.put ("K", jalview.schemes.ResidueProperties.Lys);
jalview.schemes.ResidueProperties.codonHash.put ("N", jalview.schemes.ResidueProperties.Asn);
jalview.schemes.ResidueProperties.codonHash.put ("Q", jalview.schemes.ResidueProperties.Gln);
jalview.schemes.ResidueProperties.codonHash.put ("H", jalview.schemes.ResidueProperties.His);
jalview.schemes.ResidueProperties.codonHash.put ("E", jalview.schemes.ResidueProperties.Glu);
jalview.schemes.ResidueProperties.codonHash.put ("D", jalview.schemes.ResidueProperties.Asp);
jalview.schemes.ResidueProperties.codonHash.put ("Y", jalview.schemes.ResidueProperties.Tyr);
jalview.schemes.ResidueProperties.codonHash.put ("T", jalview.schemes.ResidueProperties.Thr);
jalview.schemes.ResidueProperties.codonHash.put ("P", jalview.schemes.ResidueProperties.Pro);
jalview.schemes.ResidueProperties.codonHash.put ("A", jalview.schemes.ResidueProperties.Ala);
jalview.schemes.ResidueProperties.codonHash.put ("S", jalview.schemes.ResidueProperties.Ser);
jalview.schemes.ResidueProperties.codonHash.put ("R", jalview.schemes.ResidueProperties.Arg);
jalview.schemes.ResidueProperties.codonHash.put ("G", jalview.schemes.ResidueProperties.Gly);
jalview.schemes.ResidueProperties.codonHash.put ("W", jalview.schemes.ResidueProperties.Trp);
jalview.schemes.ResidueProperties.codonHash.put ("C", jalview.schemes.ResidueProperties.Cys);
jalview.schemes.ResidueProperties.codonHash.put ("I", jalview.schemes.ResidueProperties.Ile);
jalview.schemes.ResidueProperties.codonHash.put ("M", jalview.schemes.ResidueProperties.Met);
jalview.schemes.ResidueProperties.codonHash.put ("L", jalview.schemes.ResidueProperties.Leu);
jalview.schemes.ResidueProperties.codonHash.put ("V", jalview.schemes.ResidueProperties.Val);
jalview.schemes.ResidueProperties.codonHash.put ("F", jalview.schemes.ResidueProperties.Phe);
jalview.schemes.ResidueProperties.codonHash.put ("STOP", jalview.schemes.ResidueProperties.STOP);
}c$.ambiguityCodes = c$.prototype.ambiguityCodes =  new java.util.Hashtable ();
c$.codonHash2 = c$.prototype.codonHash2 =  new java.util.Hashtable ();
c$._ambiguityCodes = c$.prototype._ambiguityCodes =  new java.util.Hashtable ();
{
jalview.schemes.ResidueProperties.ambiguityCodes.put ("R",  Clazz.newArray (-1, ["A", "G"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("Y",  Clazz.newArray (-1, ["T", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("W",  Clazz.newArray (-1, ["A", "T"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("S",  Clazz.newArray (-1, ["G", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("M",  Clazz.newArray (-1, ["A", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("K",  Clazz.newArray (-1, ["G", "T"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("H",  Clazz.newArray (-1, ["A", "T", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("B",  Clazz.newArray (-1, ["G", "T", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("V",  Clazz.newArray (-1, ["G", "A", "C"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("D",  Clazz.newArray (-1, ["G", "A", "T"]));
jalview.schemes.ResidueProperties.ambiguityCodes.put ("N",  Clazz.newArray (-1, ["G", "A", "T", "C"]));
jalview.schemes.ResidueProperties.codonHash2.put ("AAA", "K");
jalview.schemes.ResidueProperties.codonHash2.put ("AAG", "K");
jalview.schemes.ResidueProperties.codonHash2.put ("AAC", "N");
jalview.schemes.ResidueProperties.codonHash2.put ("AAT", "N");
jalview.schemes.ResidueProperties.codonHash2.put ("CAA", "Q");
jalview.schemes.ResidueProperties.codonHash2.put ("CAG", "Q");
jalview.schemes.ResidueProperties.codonHash2.put ("CAC", "H");
jalview.schemes.ResidueProperties.codonHash2.put ("CAT", "H");
jalview.schemes.ResidueProperties.codonHash2.put ("GAA", "E");
jalview.schemes.ResidueProperties.codonHash2.put ("GAG", "E");
jalview.schemes.ResidueProperties.codonHash2.put ("GAC", "D");
jalview.schemes.ResidueProperties.codonHash2.put ("GAT", "D");
jalview.schemes.ResidueProperties.codonHash2.put ("TAC", "Y");
jalview.schemes.ResidueProperties.codonHash2.put ("TAT", "Y");
jalview.schemes.ResidueProperties.codonHash2.put ("ACA", "T");
jalview.schemes.ResidueProperties.codonHash2.put ("ACC", "T");
jalview.schemes.ResidueProperties.codonHash2.put ("ACT", "T");
jalview.schemes.ResidueProperties.codonHash2.put ("ACG", "T");
jalview.schemes.ResidueProperties.codonHash2.put ("CCA", "P");
jalview.schemes.ResidueProperties.codonHash2.put ("CCG", "P");
jalview.schemes.ResidueProperties.codonHash2.put ("CCC", "P");
jalview.schemes.ResidueProperties.codonHash2.put ("CCT", "P");
jalview.schemes.ResidueProperties.codonHash2.put ("GCA", "A");
jalview.schemes.ResidueProperties.codonHash2.put ("GCG", "A");
jalview.schemes.ResidueProperties.codonHash2.put ("GCC", "A");
jalview.schemes.ResidueProperties.codonHash2.put ("GCT", "A");
jalview.schemes.ResidueProperties.codonHash2.put ("TCA", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("TCG", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("TCC", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("TCT", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("AGC", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("AGT", "S");
jalview.schemes.ResidueProperties.codonHash2.put ("AGA", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("AGG", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("CGA", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("CGG", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("CGC", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("CGT", "R");
jalview.schemes.ResidueProperties.codonHash2.put ("GGA", "G");
jalview.schemes.ResidueProperties.codonHash2.put ("GGG", "G");
jalview.schemes.ResidueProperties.codonHash2.put ("GGC", "G");
jalview.schemes.ResidueProperties.codonHash2.put ("GGT", "G");
jalview.schemes.ResidueProperties.codonHash2.put ("TGA", "*");
jalview.schemes.ResidueProperties.codonHash2.put ("TAA", "*");
jalview.schemes.ResidueProperties.codonHash2.put ("TAG", "*");
jalview.schemes.ResidueProperties.codonHash2.put ("TGG", "W");
jalview.schemes.ResidueProperties.codonHash2.put ("TGC", "C");
jalview.schemes.ResidueProperties.codonHash2.put ("TGT", "C");
jalview.schemes.ResidueProperties.codonHash2.put ("ATA", "I");
jalview.schemes.ResidueProperties.codonHash2.put ("ATC", "I");
jalview.schemes.ResidueProperties.codonHash2.put ("ATT", "I");
jalview.schemes.ResidueProperties.codonHash2.put ("ATG", "M");
jalview.schemes.ResidueProperties.codonHash2.put ("CTA", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("CTG", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("CTC", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("CTT", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("TTA", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("TTG", "L");
jalview.schemes.ResidueProperties.codonHash2.put ("GTA", "V");
jalview.schemes.ResidueProperties.codonHash2.put ("GTG", "V");
jalview.schemes.ResidueProperties.codonHash2.put ("GTC", "V");
jalview.schemes.ResidueProperties.codonHash2.put ("GTT", "V");
jalview.schemes.ResidueProperties.codonHash2.put ("TTC", "F");
jalview.schemes.ResidueProperties.codonHash2.put ("TTT", "F");
jalview.schemes.ResidueProperties.buildAmbiguityCodonSet ();
}{
jalview.schemes.ResidueProperties.Lys.add ("AAA");
jalview.schemes.ResidueProperties.Lys.add ("AAG");
jalview.schemes.ResidueProperties.Asn.add ("AAC");
jalview.schemes.ResidueProperties.Asn.add ("AAT");
jalview.schemes.ResidueProperties.Gln.add ("CAA");
jalview.schemes.ResidueProperties.Gln.add ("CAG");
jalview.schemes.ResidueProperties.His.add ("CAC");
jalview.schemes.ResidueProperties.His.add ("CAT");
jalview.schemes.ResidueProperties.Glu.add ("GAA");
jalview.schemes.ResidueProperties.Glu.add ("GAG");
jalview.schemes.ResidueProperties.Asp.add ("GAC");
jalview.schemes.ResidueProperties.Asp.add ("GAT");
jalview.schemes.ResidueProperties.Tyr.add ("TAC");
jalview.schemes.ResidueProperties.Tyr.add ("TAT");
jalview.schemes.ResidueProperties.Thr.add ("ACA");
jalview.schemes.ResidueProperties.Thr.add ("ACG");
jalview.schemes.ResidueProperties.Thr.add ("ACC");
jalview.schemes.ResidueProperties.Thr.add ("ACT");
jalview.schemes.ResidueProperties.Pro.add ("CCA");
jalview.schemes.ResidueProperties.Pro.add ("CCG");
jalview.schemes.ResidueProperties.Pro.add ("CCC");
jalview.schemes.ResidueProperties.Pro.add ("CCT");
jalview.schemes.ResidueProperties.Ala.add ("GCA");
jalview.schemes.ResidueProperties.Ala.add ("GCG");
jalview.schemes.ResidueProperties.Ala.add ("GCC");
jalview.schemes.ResidueProperties.Ala.add ("GCT");
jalview.schemes.ResidueProperties.Ser.add ("TCA");
jalview.schemes.ResidueProperties.Ser.add ("TCG");
jalview.schemes.ResidueProperties.Ser.add ("TCC");
jalview.schemes.ResidueProperties.Ser.add ("TCT");
jalview.schemes.ResidueProperties.Ser.add ("AGC");
jalview.schemes.ResidueProperties.Ser.add ("AGT");
jalview.schemes.ResidueProperties.Arg.add ("AGA");
jalview.schemes.ResidueProperties.Arg.add ("AGG");
jalview.schemes.ResidueProperties.Arg.add ("CGA");
jalview.schemes.ResidueProperties.Arg.add ("CGG");
jalview.schemes.ResidueProperties.Arg.add ("CGC");
jalview.schemes.ResidueProperties.Arg.add ("CGT");
jalview.schemes.ResidueProperties.Gly.add ("GGA");
jalview.schemes.ResidueProperties.Gly.add ("GGG");
jalview.schemes.ResidueProperties.Gly.add ("GGC");
jalview.schemes.ResidueProperties.Gly.add ("GGT");
jalview.schemes.ResidueProperties.STOP.add ("TGA");
jalview.schemes.ResidueProperties.STOP.add ("TAA");
jalview.schemes.ResidueProperties.STOP.add ("TAG");
jalview.schemes.ResidueProperties.Trp.add ("TGG");
jalview.schemes.ResidueProperties.Cys.add ("TGC");
jalview.schemes.ResidueProperties.Cys.add ("TGT");
jalview.schemes.ResidueProperties.Ile.add ("ATA");
jalview.schemes.ResidueProperties.Ile.add ("ATC");
jalview.schemes.ResidueProperties.Ile.add ("ATT");
jalview.schemes.ResidueProperties.Met.add ("ATG");
jalview.schemes.ResidueProperties.Leu.add ("CTA");
jalview.schemes.ResidueProperties.Leu.add ("CTG");
jalview.schemes.ResidueProperties.Leu.add ("CTC");
jalview.schemes.ResidueProperties.Leu.add ("CTT");
jalview.schemes.ResidueProperties.Leu.add ("TTA");
jalview.schemes.ResidueProperties.Leu.add ("TTG");
jalview.schemes.ResidueProperties.Val.add ("GTA");
jalview.schemes.ResidueProperties.Val.add ("GTG");
jalview.schemes.ResidueProperties.Val.add ("GTC");
jalview.schemes.ResidueProperties.Val.add ("GTT");
jalview.schemes.ResidueProperties.Phe.add ("TTC");
jalview.schemes.ResidueProperties.Phe.add ("TTT");
}c$.propHash = c$.prototype.propHash =  new java.util.Hashtable ();
c$.hydrophobic = c$.prototype.hydrophobic =  new java.util.Hashtable ();
c$.polar = c$.prototype.polar =  new java.util.Hashtable ();
c$.small = c$.prototype.small =  new java.util.Hashtable ();
c$.positive = c$.prototype.positive =  new java.util.Hashtable ();
c$.negative = c$.prototype.negative =  new java.util.Hashtable ();
c$.charged = c$.prototype.charged =  new java.util.Hashtable ();
c$.aromatic = c$.prototype.aromatic =  new java.util.Hashtable ();
c$.aliphatic = c$.prototype.aliphatic =  new java.util.Hashtable ();
c$.tiny = c$.prototype.tiny =  new java.util.Hashtable ();
c$.proline = c$.prototype.proline =  new java.util.Hashtable ();
{
jalview.schemes.ResidueProperties.hydrophobic.put ("I",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("L",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("V",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("C",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("A",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("G",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("M",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("F",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("Y",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("W",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("H",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("K",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("X",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("*",  new Integer (1));
jalview.schemes.ResidueProperties.hydrophobic.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.hydrophobic.put ("P",  new Integer (0));
}{
jalview.schemes.ResidueProperties.polar.put ("Y",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("W",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("H",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("K",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("R",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("E",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("Q",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("D",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("N",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("S",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("T",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("X",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("*",  new Integer (1));
jalview.schemes.ResidueProperties.polar.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.polar.put ("P",  new Integer (0));
}{
jalview.schemes.ResidueProperties.small.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("V",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("C",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("A",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("G",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("H",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.small.put ("D",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("N",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("S",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("T",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("P",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.small.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.positive.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("H",  new Integer (1));
jalview.schemes.ResidueProperties.positive.put ("K",  new Integer (1));
jalview.schemes.ResidueProperties.positive.put ("R",  new Integer (1));
jalview.schemes.ResidueProperties.positive.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.positive.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.positive.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.negative.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("H",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("E",  new Integer (1));
jalview.schemes.ResidueProperties.negative.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("D",  new Integer (1));
jalview.schemes.ResidueProperties.negative.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.negative.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.negative.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.charged.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("H",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("K",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("R",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("E",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("D",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.charged.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.charged.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.aromatic.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("F",  new Integer (1));
jalview.schemes.ResidueProperties.aromatic.put ("Y",  new Integer (1));
jalview.schemes.ResidueProperties.aromatic.put ("W",  new Integer (1));
jalview.schemes.ResidueProperties.aromatic.put ("H",  new Integer (1));
jalview.schemes.ResidueProperties.aromatic.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.aromatic.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.aromatic.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.aliphatic.put ("I",  new Integer (1));
jalview.schemes.ResidueProperties.aliphatic.put ("L",  new Integer (1));
jalview.schemes.ResidueProperties.aliphatic.put ("V",  new Integer (1));
jalview.schemes.ResidueProperties.aliphatic.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("H",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.aliphatic.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.aliphatic.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.tiny.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("A",  new Integer (1));
jalview.schemes.ResidueProperties.tiny.put ("G",  new Integer (1));
jalview.schemes.ResidueProperties.tiny.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("H",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("S",  new Integer (1));
jalview.schemes.ResidueProperties.tiny.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("P",  new Integer (0));
jalview.schemes.ResidueProperties.tiny.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.tiny.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.proline.put ("I",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("L",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("V",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("C",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("A",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("G",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("M",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("F",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("Y",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("W",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("H",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("K",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("R",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("E",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("Q",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("D",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("N",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("S",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("T",  new Integer (0));
jalview.schemes.ResidueProperties.proline.put ("P",  new Integer (1));
jalview.schemes.ResidueProperties.proline.put ("-",  new Integer (1));
jalview.schemes.ResidueProperties.proline.put ("*",  new Integer (1));
}{
jalview.schemes.ResidueProperties.propHash.put ("hydrophobic", jalview.schemes.ResidueProperties.hydrophobic);
jalview.schemes.ResidueProperties.propHash.put ("small", jalview.schemes.ResidueProperties.small);
jalview.schemes.ResidueProperties.propHash.put ("positive", jalview.schemes.ResidueProperties.positive);
jalview.schemes.ResidueProperties.propHash.put ("negative", jalview.schemes.ResidueProperties.negative);
jalview.schemes.ResidueProperties.propHash.put ("charged", jalview.schemes.ResidueProperties.charged);
jalview.schemes.ResidueProperties.propHash.put ("aromatic", jalview.schemes.ResidueProperties.aromatic);
jalview.schemes.ResidueProperties.propHash.put ("aliphatic", jalview.schemes.ResidueProperties.aliphatic);
jalview.schemes.ResidueProperties.propHash.put ("tiny", jalview.schemes.ResidueProperties.tiny);
jalview.schemes.ResidueProperties.propHash.put ("proline", jalview.schemes.ResidueProperties.proline);
jalview.schemes.ResidueProperties.propHash.put ("polar", jalview.schemes.ResidueProperties.polar);
}{
var propMatrixF =  Clazz.newIntArray (23, 23, 0);
var propMatrixPos =  Clazz.newIntArray (23, 23, 0);
var propMatrixEpos =  Clazz.newIntArray (23, 23, 0);
for (var i = 0; i < 23; i++) {
var maxF = 0;
var maxP = 0;
var maxEP = 0;
var ic = "";
if (jalview.schemes.ResidueProperties.aa.length > i) {
ic += jalview.schemes.ResidueProperties.aa[i];
} else {
ic = "-";
}for (var j = i + 1; j < 23; j++) {
var jc = "";
if (jalview.schemes.ResidueProperties.aa.length > j) {
jc += jalview.schemes.ResidueProperties.aa[j];
} else {
jc = "-";
}propMatrixF[i][j] = 0;
propMatrixPos[i][j] = 0;
propMatrixEpos[i][j] = 0;
for (var en = jalview.schemes.ResidueProperties.propHash.keys (); en.hasMoreElements (); ) {
var ph = en.nextElement ();
var pph = jalview.schemes.ResidueProperties.propHash.get (ph);
if (pph.get (ic) != null && pph.get (jc) != null) {
var icp = pph.get (ic).intValue ();
var jcp = pph.get (jc).intValue ();
propMatrixPos[i][j] += icp == jcp && icp > 0 ? 2 : 0;
propMatrixPos[j][i] += icp == jcp && icp > 0 ? 2 : 0;
propMatrixF[i][j] += icp == jcp ? 2 : 0;
propMatrixF[j][i] += icp == jcp ? 2 : 0;
propMatrixEpos[i][j] += icp == jcp ? (1 + icp * 2) : 0;
propMatrixEpos[j][i] += icp == jcp ? (1 + icp * 2) : 0;
}}
if (maxF < propMatrixF[i][j]) {
maxF = propMatrixF[i][j];
}if (maxP < propMatrixPos[i][j]) {
maxP = propMatrixPos[i][j];
}if (maxEP < propMatrixEpos[i][j]) {
maxEP = propMatrixEpos[i][j];
}}
propMatrixF[i][i] = maxF;
propMatrixPos[i][i] = maxP;
propMatrixEpos[i][i] = maxEP;
}
jalview.schemes.ResidueProperties.scoreMatrices.put ("PID",  new jalview.analysis.scoremodels.PIDScoreModel ());
jalview.schemes.ResidueProperties.scoreMatrices.put ("Displayed Features",  new jalview.analysis.scoremodels.FeatureScoreModel ());
}Clazz.defineStatics (c$,
"toDssp3State", null);
{
jalview.schemes.ResidueProperties.toDssp3State =  new java.util.Hashtable ();
jalview.schemes.ResidueProperties.toDssp3State.put ("H", "H");
jalview.schemes.ResidueProperties.toDssp3State.put ("E", "E");
jalview.schemes.ResidueProperties.toDssp3State.put ("C", " ");
jalview.schemes.ResidueProperties.toDssp3State.put (" ", " ");
jalview.schemes.ResidueProperties.toDssp3State.put ("T", " ");
jalview.schemes.ResidueProperties.toDssp3State.put ("B", "E");
jalview.schemes.ResidueProperties.toDssp3State.put ("G", "H");
jalview.schemes.ResidueProperties.toDssp3State.put ("I", "H");
jalview.schemes.ResidueProperties.toDssp3State.put ("X", " ");
}Clazz.defineStatics (c$,
"toRNAssState", null,
"RNAcloseParen",  Clazz.newBooleanArray (255, false));
{
jalview.schemes.ResidueProperties.toRNAssState =  new java.util.Hashtable ();
jalview.schemes.ResidueProperties.toRNAssState.put (")", "(");
jalview.schemes.ResidueProperties.toRNAssState.put ("(", "(");
jalview.schemes.ResidueProperties.toRNAssState.put ("]", "[");
jalview.schemes.ResidueProperties.toRNAssState.put ("[", "[");
jalview.schemes.ResidueProperties.toRNAssState.put ("{", "{");
jalview.schemes.ResidueProperties.toRNAssState.put ("}", "{");
jalview.schemes.ResidueProperties.toRNAssState.put (">", ">");
jalview.schemes.ResidueProperties.toRNAssState.put ("<", ">");
jalview.schemes.ResidueProperties.toRNAssState.put ("A", "A");
jalview.schemes.ResidueProperties.toRNAssState.put ("a", "A");
jalview.schemes.ResidueProperties.toRNAssState.put ("B", "B");
jalview.schemes.ResidueProperties.toRNAssState.put ("b", "B");
jalview.schemes.ResidueProperties.toRNAssState.put ("C", "C");
jalview.schemes.ResidueProperties.toRNAssState.put ("c", "C");
jalview.schemes.ResidueProperties.toRNAssState.put ("D", "D");
jalview.schemes.ResidueProperties.toRNAssState.put ("d", "D");
jalview.schemes.ResidueProperties.toRNAssState.put ("E", "E");
jalview.schemes.ResidueProperties.toRNAssState.put ("e", "E");
jalview.schemes.ResidueProperties.toRNAssState.put ("F", "F");
jalview.schemes.ResidueProperties.toRNAssState.put ("f", "F");
jalview.schemes.ResidueProperties.toRNAssState.put ("G", "G");
jalview.schemes.ResidueProperties.toRNAssState.put ("g", "G");
jalview.schemes.ResidueProperties.toRNAssState.put ("H", "H");
jalview.schemes.ResidueProperties.toRNAssState.put ("h", "H");
jalview.schemes.ResidueProperties.toRNAssState.put ("I", "I");
jalview.schemes.ResidueProperties.toRNAssState.put ("i", "I");
jalview.schemes.ResidueProperties.toRNAssState.put ("J", "J");
jalview.schemes.ResidueProperties.toRNAssState.put ("j", "J");
jalview.schemes.ResidueProperties.toRNAssState.put ("K", "K");
jalview.schemes.ResidueProperties.toRNAssState.put ("k", "K");
jalview.schemes.ResidueProperties.toRNAssState.put ("L", "L");
jalview.schemes.ResidueProperties.toRNAssState.put ("l", "L");
jalview.schemes.ResidueProperties.toRNAssState.put ("M", "M");
jalview.schemes.ResidueProperties.toRNAssState.put ("m", "M");
jalview.schemes.ResidueProperties.toRNAssState.put ("N", "N");
jalview.schemes.ResidueProperties.toRNAssState.put ("n", "N");
jalview.schemes.ResidueProperties.toRNAssState.put ("O", "O");
jalview.schemes.ResidueProperties.toRNAssState.put ("o", "O");
jalview.schemes.ResidueProperties.toRNAssState.put ("P", "P");
jalview.schemes.ResidueProperties.toRNAssState.put ("p", "P");
jalview.schemes.ResidueProperties.toRNAssState.put ("Q", "Q");
jalview.schemes.ResidueProperties.toRNAssState.put ("q", "Q");
jalview.schemes.ResidueProperties.toRNAssState.put ("R", "R");
jalview.schemes.ResidueProperties.toRNAssState.put ("r", "R");
jalview.schemes.ResidueProperties.toRNAssState.put ("S", "S");
jalview.schemes.ResidueProperties.toRNAssState.put ("s", "S");
jalview.schemes.ResidueProperties.toRNAssState.put ("T", "T");
jalview.schemes.ResidueProperties.toRNAssState.put ("t", "T");
jalview.schemes.ResidueProperties.toRNAssState.put ("U", "U");
jalview.schemes.ResidueProperties.toRNAssState.put ("u", "U");
jalview.schemes.ResidueProperties.toRNAssState.put ("V", "V");
jalview.schemes.ResidueProperties.toRNAssState.put ("v", "V");
jalview.schemes.ResidueProperties.toRNAssState.put ("W", "W");
jalview.schemes.ResidueProperties.toRNAssState.put ("w", "W");
jalview.schemes.ResidueProperties.toRNAssState.put ("X", "X");
jalview.schemes.ResidueProperties.toRNAssState.put ("x", "X");
jalview.schemes.ResidueProperties.toRNAssState.put ("Y", "Y");
jalview.schemes.ResidueProperties.toRNAssState.put ("y", "Y");
jalview.schemes.ResidueProperties.toRNAssState.put ("Z", "Z");
jalview.schemes.ResidueProperties.toRNAssState.put ("z", "Z");
for (var p = 0; p < jalview.schemes.ResidueProperties.RNAcloseParen.length; p++) {
jalview.schemes.ResidueProperties.RNAcloseParen[p] = false;
}
for (var k, $k = jalview.schemes.ResidueProperties.toRNAssState.keySet ().iterator (); $k.hasNext () && ((k = $k.next ()) || true);) {
jalview.schemes.ResidueProperties.RNAcloseParen[k.charCodeAt (0)] = k.charAt (0) != jalview.schemes.ResidueProperties.toRNAssState.get (k).charAt (0);
}
}});
